function Create(self)

	self.decreaseExplodeTimer = Timer()
	self.decreaseExplodeDelay = 250
	
	self.increaseExplodeTimer = Timer()
	self.increaseExplodeDelay = 100
	
	self.gracePeriodTimer = Timer()
	self.gracePeriodDelay = 150		--They have a tendency to spam their jetpacks like all actors, this should reduce AI problems a bit
	
	self.AIDownTime = 1000;
	self.AIDownTimer = Timer();
	self.AIDownTimerSet = false;
	
	self.AIDown = false;

	if IsAHuman(self:GetRootParent()) then
		self.parent = ToAHuman(self:GetRootParent())
	else
		self.parent = nil;
	end

	self.safeProbability = self.parent:NumberValueExists("Safe Probability") and self.parent:GetNumberValue("Safe Probability") or 10
	self.maxProbability = self.parent:NumberValueExists("Max Probability") and self.parent:GetNumberValue("Max Probability") + self.safeProbability or 100 + self.safeProbability
	self.probability = math.random(self.safeProbability, self.maxProbability)

	self.AIWisdomChance = self.parent:NumberValueExists("Wisdom Chance") and self.parent:GetNumberValue("Wisdom Chance") or 0.2		--Chance of stopping the jetpack after the risk factor is surpassed
	self.AIRiskFactor = self.parent:NumberValueExists("Risk Factor") and self.parent:GetNumberValue("Risk Factor") or 25	--+ safe pRobability. The minimum where the AI starts to stop their jetpack

	self.chance = 0
	
	self.smokeChance = 0.5/(self.safeProbability)

end

function Update(self)
--[[
	if self.AIDownTimerSet == true then
		self.AIDownTimerSet = false
		self.AIDownTimer:Reset();
		self.AIDown = true;
	end

	if not self.parent:IsPlayerControlled() then
		if not self.AIDownTimer:IsPastSimMS(self.AIDownTime) and self.AIDown then
			self:EnableEmission(false)
		else
			self.AIDown = false;
		end
	end
--]]
	if self.chance <= self.safeProbability then
		self.smokeChance = (0.5/(self.safeProbability))*self.chance
	else
		self.smokeChance = 0.5 + (0.5/(self.maxProbability))*(self.chance-self.safeProbability)
	end

	if math.random() <= self.smokeChance then
		local smokeEffect = CreateMOSParticle("Tiny Smoke Ball 1");
		smokeEffect.Pos = self.Pos + Vector((math.random(0 , 2)*self.FlipFactor) , (math.random(-10 , 0))):RadRotate(self.RotAngle);
		smokeEffect.Vel = self.Vel + Vector((math.random(-2 , 1)*self.FlipFactor), 0):RadRotate(self.RotAngle)
		MovableMan:AddParticle(smokeEffect);
	end

	if self.chance >= (self.safeProbability - 3) then	
		if math.random() <= (self.smokeChance*0.5) then
			local smokeEffect = CreateMOSParticle("Small Smoke Ball 1");
			smokeEffect.Pos = self.Pos + Vector((math.random(1 , 3)*self.FlipFactor) , (math.random(-10 , 0))):RadRotate(self.RotAngle);
			smokeEffect.Vel = self.Vel + Vector((math.random(-2 , 1)*self.FlipFactor), 0):RadRotate(self.RotAngle)
			MovableMan:AddParticle(smokeEffect);
		end
	end

	if self and self:IsEmitting() then
		self.decreaseExplodeTimer:Reset()
		
		if self.gracePeriodTimer:IsPastSimMS(self.gracePeriodDelay) then
	
			if self.increaseExplodeTimer:IsPastSimMS(self.increaseExplodeDelay) then
				self.chance = self.chance + 1
				
				if self.chance >= self.probability then
					self.parent.Health = 0;
					self:GibThis()
				else
					self.probability = math.random(self.safeProbability, self.maxProbability)
				end	

				self.increaseExplodeTimer:Reset()
				
--				if math.random() <= self.AIWisdomChance and self.chance <= self.safeProbability * self.AIRiskFactor then
--					self.AIDownTimerSet = true;
--				end
			end
		end
	else
		self.increaseExplodeTimer:Reset()
		self.gracePeriodTimer:Reset()

		if self.decreaseExplodeTimer:IsPastSimMS(self.decreaseExplodeDelay) then
			self.decreaseExplodeTimer:Reset()
			if self.chance > 0 then
				self.chance = self.chance - 1
			end
		end
	end
end