	--- To-Do: Instead of Turret MG AEmitter, make it just an Attachable ---
	--- And the bullet + effects a differente, spawnable emitter ---

function Create(self)

	self.searchRange = 350;	--Detection area diameter or max ray distance to search enemies from, in px

	--Toggle visibility of the aim area / trace to see how the detection works
	self.showAim = false;
	
	self.BurstSpacing = 250
	
	self.performanceTimer = Timer()
	self.performanceDelay = 75
	
	
	if IsACrab(self:GetRootParent()) then
		self.parent = ToACrab(self:GetRootParent());
	else
		self.parent = nil
	end

	self.aimCounter = 0

end

function Update(self)

	if self.parent then
		local target;
		if target == nil then
			self.RotAngle = self.parent.RotAngle
		end

		local aimTrace = Vector(self.searchRange * self.FlipFactor, 80 - self.aimCounter):RadRotate(self.parent.RotAngle);

		--Search for MOs directly in line of sight of two rays

		if self.performanceTimer:IsPastSimMS(self.performanceDelay) then
			
			local moCheck = SceneMan:CastMORay(self.Pos, aimTrace, self.parent.ID, self.Team, rte.airID, false, 5);
			if moCheck ~= rte.NoMOID then
				local check = MovableMan:GetMOFromID(MovableMan:GetMOFromID(moCheck).RootID);
				if check and IsActor(check) and ToActor(check).Status < Actor.INACTIVE then
					target = check
				end
			end

			if target == nil then
				if self.aimCounter < 120 then
					self.aimCounter = self.aimCounter + 15
				else
					self.aimCounter = 0
				end
			end
			
			self.performanceTimer:Reset()
		end

		if target then
			local aimTarget = SceneMan:ShortestDistance(self.Pos, target.Pos + Vector(0,-10), SceneMan.SceneWrapsX);
			local terrCheck = SceneMan:CastStrengthRay(self.Pos, aimTarget, 40, Vector(), 5, 0, SceneMan.SceneWrapsX);
			if terrCheck == false then
				self.RotAngle = self.HFlipped and aimTarget.AbsRadAngle + math.pi or aimTarget.AbsRadAngle;
				self:EnableEmission(true);
				self:TriggerBurst();
			end
			
			if self:IsSetToBurst() then
				color = 254;	--Debug trace color: white
			end
		end
		--Debug: visualize aim traces
		if self.showAim == true then
			PrimitiveMan:DrawLinePrimitive(self.Team, self.Pos, self.Pos + aimTrace, 13);
		end
	end
end