function Create(self)

	self.RotAngle = 0		--Initial rot angle to 0 so it doesn't spawn tilted

	self.isStable = true;
	self.halfGround = false;
	self.fullGround = false;
	self.canDrive = false;
	
	self.angleNum = 0;
	self.rotateLeft = false
	self.rotateRight = false

	for attachable in self.Attachables do
		if attachable.PresetName == "Loyalist Armored Car Wheel Back" then
			self.Wheel1 = attachable;
		end
		if attachable.PresetName == "Loyalist Armored Car Wheel Front" then
			self.Wheel2 = attachable;
		end
	end

	self.Accel = 0.2
	self.MaxAccel = 12
	self.DeAccel = 0.15

	self.wheelsRotCounter = 0
	
	self.debugLines = false

end

function Update(self)
	
	if self.halfGround == false and self.fullGround == false then
		local rotateUp = self:GetController():IsState(Controller.MOVE_UP);
		local rotateDown = self:GetController():IsState(Controller.MOVE_DOWN);
		
		if rotateUp then
			self.AngularVel = self.AngularVel + 0.05
		elseif rotateDown then
			self.AngularVel = self.AngularVel - 0.05
		end

	end

	if self.isStable then

		local Wheel1FixedPos = self.Pos + Vector(-30*self.FlipFactor, 13):RadRotate(self.RotAngle)		-- -30
		local Wheel2FixedPos = self.Pos + Vector(32*self.FlipFactor, 13):RadRotate(self.RotAngle)		--32	

		local WheelRangeFixed = Vector(0, 9):RadRotate(self.RotAngle)	--Longer so it doesn't bug	
		local WheelRangeFixedLR = Vector(9*self.FlipFactor, 3):RadRotate(self.RotAngle)	--Longer so it doesn't bug
		local WheelRangeFixedRL = Vector(-9*self.FlipFactor, 3):RadRotate(self.RotAngle)	--Longer so it doesn't bug
	
		if self.debugLines == true then
			PrimitiveMan:DrawLinePrimitive(self.Team, Wheel1FixedPos, Wheel1FixedPos + WheelRangeFixed, 162);
			PrimitiveMan:DrawLinePrimitive(self.Team, Wheel1FixedPos, Wheel1FixedPos + WheelRangeFixedLR, 162);
			PrimitiveMan:DrawLinePrimitive(self.Team, Wheel1FixedPos, Wheel1FixedPos + WheelRangeFixedRL, 162);
			
			PrimitiveMan:DrawLinePrimitive(self.Team, Wheel2FixedPos, Wheel2FixedPos + WheelRangeFixed, 162);
			PrimitiveMan:DrawLinePrimitive(self.Team, Wheel2FixedPos, Wheel2FixedPos + WheelRangeFixedLR, 162);
			PrimitiveMan:DrawLinePrimitive(self.Team, Wheel2FixedPos, Wheel2FixedPos + WheelRangeFixedRL, 162);
		end
		
		local Wheel1Check1 = SceneMan:CastObstacleRay(Wheel1FixedPos, WheelRangeFixed, Vector(), Vector(), self.ID, self.Team, rte.grassID, 0)
		local Wheel1Check2 = SceneMan:CastObstacleRay(Wheel1FixedPos, WheelRangeFixedLR, Vector(), Vector(), self.ID, self.Team, rte.grassID, 0)
		local Wheel1Check3 = SceneMan:CastObstacleRay(Wheel1FixedPos, WheelRangeFixedRL, Vector(), Vector(), self.ID, self.Team, rte.grassID, 0)
		
		local Wheel2Check1 = SceneMan:CastObstacleRay(Wheel2FixedPos, WheelRangeFixed, Vector(), Vector(), self.ID, self.Team, rte.grassID, 0)
		local Wheel2Check2 = SceneMan:CastObstacleRay(Wheel2FixedPos, WheelRangeFixedLR, Vector(), Vector(), self.ID, self.Team, rte.grassID, 0)
		local Wheel2Check3 = SceneMan:CastObstacleRay(Wheel2FixedPos, WheelRangeFixedRL, Vector(), Vector(), self.ID, self.Team, rte.grassID, 0)
		
		local Wheel1Fixed = Wheel1Check1 ~= -1 and Wheel1Check1 or Wheel1Check2 ~= -1 and Wheel1Check2 or Wheel1Check3 ~= -1 and Wheel1Check3 or -1
		local Wheel2Fixed = Wheel2Check1 ~= -1 and Wheel2Check1 or Wheel2Check2 ~= -1 and Wheel2Check2 or Wheel2Check3 ~= -1 and Wheel2Check3 or -1

		if Wheel1Fixed ~= -1 and Wheel2Fixed ~= -1 then			--Full ground. "Generic" specifications. Upwards rotation. 0 Angular vel
			self.fullGround = true;
			self.halfGround = false;
			
			local push = Wheel1Fixed < Wheel2Fixed and (8 - Wheel1Fixed) or (8 - Wheel2Fixed)
			
			if Wheel1Fixed <= 8 or Wheel2Fixed <= 8 then
				self.Vel.Y = 0
				if Wheel1Fixed < 8 or Wheel2Fixed < 8 then
					self.Pos = self.Pos - Vector(0, push):RadRotate(self.RotAngle)
				end
			end
		
		elseif Wheel1Fixed ~= -1 or Wheel2Fixed ~= -1 then		--Half ground. Wheel specific. Downards rotation. Dependant angular vel for stability
			self.fullGround = false;
			self.halfGround = true;

			local push = 0;

			if Wheel1Fixed == -1 then				--This specific system could be converted to rotation (Since rotation also helps unstuck wheels)
				push = (8 - Wheel2Fixed)*0.5 
				if Wheel2Fixed <= 8 then
					self.Vel.Y = 0
					self.AngularVel = self.AngularVel + 0.2*self.FlipFactor + 0.025*math.abs(self.Vel.X)*self.FlipFactor
					if Wheel2Fixed <= 8 then
						self.Pos = self.Pos - Vector(0, push):RadRotate(self.RotAngle)
					end
				end
			elseif Wheel2Fixed == -1 then
				push = (8 - Wheel1Fixed)*0.5 
				if Wheel1Fixed <= 8 then
					self.Vel.Y = 0
					self.AngularVel = self.AngularVel - 0.2*self.FlipFactor - 0.005*math.abs(self.Vel.X)*self.FlipFactor
					if Wheel1Fixed <= 8 then
						self.Pos = self.Pos - Vector(0, push):RadRotate(self.RotAngle)
					end
				end				
			end
			
		elseif self.halfGround or self.fullGround then					--We ere fine and now we trippin balls (Flying, triped, etc). Normal Angular Vel. Previous vel for basic flight
			self.Vel = Vector(self.Vel.X, self.Vel.Y):RadRotate(self.RotAngle)
			
			self.halfGround = false
			self.fullGround = false;
		end

		if self.fullGround then		--Might be possible to integrate above, and with angular vel instead of rotation.
		
			if Wheel2Fixed < Wheel1Fixed-1 then
				self.rotateLeft = true
			elseif Wheel2Fixed > Wheel1Fixed+1 then
				self.rotateRight = true
			end

			if self.rotateRight then
				self.AngularVel = self.AngularVel - 0.1*self.FlipFactor*math.abs(self.Vel.X)
				self.rotateRight = false
			elseif self.rotateLeft then
				self.AngularVel = self.AngularVel + 0.1*self.FlipFactor*math.abs(self.Vel.X)
				self.rotateLeft = false
			else
				self.AngularVel = 0
			end

		end

		if self.halfGround or self.fullGround then
			self.canDrive = true
		else
			self.canDrive = false
			
			self.wheelsRotCounter = self.wheelsRotCounter - self.FlipFactor*0.025*math.abs(self.Vel.X)
			
			--- ADD NON TRACK WHEEL ANIM HERE -----
		end
		
		if self.canDrive then
		
			self.isMovingLeft = self:GetController():IsState(Controller.MOVE_LEFT);
			self.isMovingRight = self:GetController():IsState(Controller.MOVE_RIGHT);
			
			local moving = (self.isMovingLeft or self.isMovingRight) and true or false;
			
			if moving then
			
				for i = 1, 8 do
					local pixelDelete = CreateMOPixel("Armoerd Car Wheel Terrain Cleaner", "Loyalists.rte")
					pixelDelete.Pos = self.Pos + Vector(-28*self.FlipFactor,14+i):RadRotate(self.RotAngle)
					pixelDelete.Vel = self.Vel + Vector(self.Vel.X*0.85,0):RadRotate(self.RotAngle)
					pixelDelete.Team = self.Team; 
					MovableMan:AddParticle(pixelDelete)
				end

				for i = 1, 8 do
					local pixelDelete = CreateMOPixel("Armoerd Car Wheel Terrain Cleaner", "Loyalists.rte")
					pixelDelete.Pos = self.Pos + Vector(35*self.FlipFactor,14+i):RadRotate(self.RotAngle)
					pixelDelete.Vel = self.Vel + Vector(self.Vel.X*0.85,0):RadRotate(self.RotAngle)
					pixelDelete.Team = self.Team; 
					MovableMan:AddParticle(pixelDelete)
				end
			end
			
			if self.isMovingLeft then
				if self.Vel.X > (-self.MaxAccel) then
					self.Vel = self.Vel + Vector(-self.Accel ,0):RadRotate(self.RotAngle)
				end
			elseif self.isMovingRight then	
				if self.Vel.X < self.MaxAccel then
					self.Vel = self.Vel + Vector(self.Accel ,0):RadRotate(self.RotAngle)
				end
			else
				if self.Vel.X >= -self.DeAccel and self.Vel.X <= self.DeAccel then
					self.Vel = Vector(0, self.Vel.Y):RadRotate(self.RotAngle)
				elseif self.Vel.X > self.DeAccel then
					self.Vel = self.Vel + Vector(-self.DeAccel, 0):RadRotate(self.RotAngle)
				elseif self.Vel.X < -self.DeAccel then
					self.Vel = self.Vel + Vector(self.DeAccel, 0):RadRotate(self.RotAngle)
				end
			end
		end
	end

	self.wheelsRotCounter = self.wheelsRotCounter - self.FlipFactor*0.025*math.abs(self.Vel.X)

	if math.abs(self.wheelsRotCounter) > 6.3 then		--Full rotation
		self.wheelsRotCounter = 0
	end

	self.Wheel1.RotAngle = self.wheelsRotCounter
	self.Wheel2.RotAngle = self.wheelsRotCounter

	if self.Health <= 0 then
		self:GibThis()
	end

end

function Destroy(self)

	local driver = CreateAHuman("Loyal Officer", "Loyalists.rte")
	local sidearm1 = RandomHDFirearm("Weapons - Secondary" , "Loyalists.rte");
	driver:AddInventoryItem(sidearm1)
	driver.Pos = self.Pos + Vector(20*self.FlipFactor, -5):RadRotate(self.RotAngle)
	driver.Vel = self.Vel
	driver.RotAngle = self.RotAngle
	driver.HFlipped = self.HFlipped
	driver.AIMode = 1
	driver.Team = self.Team
	MovableMan:AddActor(driver)

	local passanger2 = CreateAHuman("Loyalist", "Loyalists.rte")
	local mainarm2 = RandomHDFirearm("Weapons - Light" , "Loyalists.rte");
	local sidearm2 = RandomHDFirearm("Weapons - Secondary" , "Loyalists.rte");
	passanger2:AddInventoryItem(sidearm2)
	passanger2.Pos = self.Pos + Vector(0, -15):RadRotate(self.RotAngle)
	passanger2.Vel = self.Vel
	passanger2.RotAngle = self.RotAngle
	passanger2.HFlipped = self.HFlipped
	passanger2.AIMode = 1
	passanger2.Team = self.Team
	MovableMan:AddActor(passanger2)

	local passanger3 = CreateAHuman("Loyalist", "Loyalists.rte")
	local sidearm3 = RandomHDFirearm("Weapons - Secondary" , "Loyalists.rte");
	passanger3:AddInventoryItem(sidearm3)
	passanger3.Pos = self.Pos + Vector(20*self.FlipFactor, -5):RadRotate(self.RotAngle)
	passanger3.Vel = self.Vel
	passanger3.RotAngle = self.RotAngle
	passanger3.HFlipped = self.HFlipped
	passanger3.AIMode = 1
	passanger3.Team = self.Team
	MovableMan:AddActor(passanger3)

end