function Create(self)

	---- Engine Stuff
	for attachable in self.Attachables do
		if attachable.PresetName == "Loyalist Tank Engine" then
			self.engine = attachable;
		end
	end

	self.RotAngle = 0

	self.isStable = true;
	self.halfGround = false;
	self.fullGround = false;
	self.canDrive = false;
	
	self.angleNum = 0;
	self.rotateLeft = false
	self.rotateRight = false

	self.Accel = 0.15
	self.MaxAccel = 6.5
	self.DeAccel = 0.1
	
	self.debugLines = false

end

function Update(self)
	
	if self.halfGround == false and self.fullGround == false then
		local rotateUp = self:GetController():IsState(Controller.MOVE_UP);
		local rotateDown = self:GetController():IsState(Controller.MOVE_DOWN);
		
		if rotateUp then
			self.AngularVel = self.AngularVel + 0.05
		elseif rotateDown then
			self.AngularVel = self.AngularVel - 0.05
		end

	end

	if self.isStable then
	
		------------------------- Track specific Movement enabler ------------------------------
		--------------- Different to wheels, tracks only need a bit of terrain -----------------
		------------------- anywhere on its convenient flat tracks to move ---------------------

		local TrackMovementPos = self.Pos + Vector(-33*self.FlipFactor, 24):RadRotate(self.RotAngle)			
		local TrackMovementRange = Vector(56*self.FlipFactor, 0):RadRotate(self.RotAngle)	--Longer so it doesn't bug
	
		if self.debugLines == true then
			PrimitiveMan:DrawLinePrimitive(self.Team, TrackMovementPos, TrackMovementPos + TrackMovementRange, 13);
		end
		
		local TrackMovementCheck = SceneMan:CastObstacleRay(TrackMovementPos, TrackMovementRange, Vector(), Vector(), self.ID, self.Team, rte.airID, 0)
	
		if TrackMovementCheck ~= -1 then
			self.canDrive = true
		else
			self.canDrive = false
		end		

		----------------------------------------------------------------------------------------

		local Track1FixedPos = self.Pos + Vector(-33*self.FlipFactor, 13):RadRotate(self.RotAngle)
		local Track2FixedPos = self.Pos + Vector(30*self.FlipFactor, 13):RadRotate(self.RotAngle)
		local Track3FixedPos = self.Pos + Vector(12*self.FlipFactor, 13):RadRotate(self.RotAngle)
		local Track4FixedPos = self.Pos + Vector(-13*self.FlipFactor, 13):RadRotate(self.RotAngle)			
		local TrackRangeFixed = Vector(0, 12):RadRotate(self.RotAngle)	--Longer so it doesn't bug
	
		if self.debugLines == true then
			PrimitiveMan:DrawLinePrimitive(self.Team, Track1FixedPos, Track1FixedPos + TrackRangeFixed, 162);
			PrimitiveMan:DrawLinePrimitive(self.Team, Track2FixedPos, Track2FixedPos + TrackRangeFixed, 162);
			PrimitiveMan:DrawLinePrimitive(self.Team, Track3FixedPos, Track3FixedPos + TrackRangeFixed, 162);
			PrimitiveMan:DrawLinePrimitive(self.Team, Track4FixedPos, Track4FixedPos + TrackRangeFixed, 162);
		end
		
		local Track1Fixed = SceneMan:CastObstacleRay(Track1FixedPos, TrackRangeFixed, Vector(), Vector(), self.ID, self.Team, rte.airID, 0)
		local Track2Fixed = SceneMan:CastObstacleRay(Track2FixedPos, TrackRangeFixed, Vector(), Vector(), self.ID, self.Team, rte.airID, 0)
		local Track3Fixed = SceneMan:CastObstacleRay(Track3FixedPos, TrackRangeFixed, Vector(), Vector(), self.ID, self.Team, rte.airID, 0)
		local Track4Fixed = SceneMan:CastObstacleRay(Track4FixedPos, TrackRangeFixed, Vector(), Vector(), self.ID, self.Team, rte.airID, 0)
		
		local TrackLFixed = (Track1Fixed ~= -1 and Track4Fixed ~= -1) and (Track1Fixed + Track4Fixed)*0.5 or Track1Fixed ~= -1 and Track1Fixed or Track4Fixed ~= -1 and Track4Fixed or -1
		local TrackRFixed = (Track2Fixed ~= -1 and Track3Fixed ~= -1) and (Track2Fixed + Track3Fixed)*0.5 or Track2Fixed ~= -1 and Track2Fixed or Track3Fixed ~= -1 and Track3Fixed or -1

		if TrackLFixed ~= -1 and TrackRFixed ~= -1 then			--Full ground. "Generic" specifications. Upwards rotation. 0 Angular vel
			self.fullGround = true;
			self.halfGround = false;
			
			local push = TrackLFixed < TrackRFixed and (10 - TrackLFixed) or (10 - TrackRFixed)
			
			if TrackLFixed <= 10 or TrackRFixed <= 10 then
				self.Vel.Y = 0
				if TrackLFixed < 10 or TrackRFixed < 10 then
					self.Pos = self.Pos - Vector(0, push)
				end
			end
		
		elseif TrackLFixed ~= -1 or TrackRFixed ~= -1  then		--Half ground. Track specific. Downards rotation. Dependant angular vel for stability
			self.fullGround = false;
			self.halfGround = true;

			local push = 0;

			if TrackLFixed == -1 then				--This specific system could be converted to rotation (Since rotation also helps unstuck Tracks)
				push = (10 - TrackRFixed)*0.5 
				if TrackRFixed <= 10 then
					self.Vel.Y = 0
					self.AngularVel = self.AngularVel + 0.2*self.FlipFactor + 0.025*math.abs(self.Vel.X)*self.FlipFactor
					if TrackRFixed <= 10 then
						self.Pos = self.Pos - Vector(0, push):RadRotate(self.RotAngle)
					end
				end
			elseif TrackRFixed == -1 then
				push = (10 - TrackLFixed)*0.5 
				if TrackLFixed <= 10 then
					self.Vel.Y = 0
					self.AngularVel = self.AngularVel - 0.2*self.FlipFactor - 0.005*math.abs(self.Vel.X)*self.FlipFactor
					if TrackLFixed <= 10 then
						self.Pos = self.Pos - Vector(0, push):RadRotate(self.RotAngle)
					end
				end				
			end
			
		elseif self.halfGround or self.fullGround then					--We ere fine and now we trippin balls (Flying, triped, etc). Normal Angular Vel. Previous vel for basic flight
			self.Vel = Vector(self.Vel.X, self.Vel.Y):RadRotate(self.RotAngle)
			
			self.halfGround = false
			self.fullGround = false;
		end

		if self.fullGround then		--Might be possible to integrate above, and with angular vel instead of rotation.
		
			if TrackRFixed < TrackLFixed-1 then
				self.rotateLeft = true
			elseif TrackRFixed > TrackLFixed+1 then
				self.rotateRight = true
			end

			if self.rotateRight then
				self.AngularVel = self.AngularVel - 0.1*self.FlipFactor*math.abs(self.Vel.X)
				self.rotateRight = false
			elseif self.rotateLeft then
				self.AngularVel = self.AngularVel + 0.1*self.FlipFactor*math.abs(self.Vel.X)
				self.rotateLeft = false
			else
				self.AngularVel = 0
			end

		end
		
		if self.canDrive then
				
			self.isMovingLeft = self:GetController():IsState(Controller.MOVE_LEFT);
			self.isMovingRight = self:GetController():IsState(Controller.MOVE_RIGHT);
			
			local moving = (self.isMovingLeft or self.isMovingRight) and true or false;
			
			if moving then

				for i = 1, 8 do
					local pixelDelete = CreateMOPixel("Tank Track Terrain Cleaner", "Loyalists.rte")
					pixelDelete.Pos = self.Pos + Vector(30*self.FlipFactor,15+i):RadRotate(self.RotAngle)
					pixelDelete.Vel = self.Vel + Vector(math.abs(self.Vel.X)*3.5*self.FlipFactor, 0):RadRotate(self.RotAngle)
					pixelDelete.Team = self.Team; 
					MovableMan:AddParticle(pixelDelete)
				end

				for i = 1, 8 do
					local pixelDelete = CreateMOPixel("Tank Track Terrain Cleaner", "Loyalists.rte")
					pixelDelete.Pos = self.Pos + Vector(0*self.FlipFactor,15+i):RadRotate(self.RotAngle)
					pixelDelete.Vel = self.Vel + Vector(math.abs(self.Vel.X)*3.5*self.FlipFactor, 0):RadRotate(self.RotAngle)
					pixelDelete.Team = self.Team; 
					MovableMan:AddParticle(pixelDelete)
				end

				for i = 1, 8 do
					local pixelDelete = CreateMOPixel("Tank Track Terrain Cleaner", "Loyalists.rte")
					pixelDelete.Pos = self.Pos + Vector(-30*self.FlipFactor,15+i):RadRotate(self.RotAngle)
					pixelDelete.Vel = self.Vel + Vector(math.abs(self.Vel.X)*3.5*self.FlipFactor, 0):RadRotate(self.RotAngle)
					pixelDelete.Team = self.Team; 
					MovableMan:AddParticle(pixelDelete)
				end

			end
			
			if self.isMovingLeft then
				if self.Vel.X > (-self.MaxAccel) then
					self.Vel = self.Vel + Vector(-self.Accel ,0):RadRotate(self.RotAngle-0.3)
				end
			elseif self.isMovingRight then	
				if self.Vel.X < self.MaxAccel then
					self.Vel = self.Vel + Vector(self.Accel ,0):RadRotate(self.RotAngle-0.3)
				end
			else
				if self.Vel.X >= -self.DeAccel and self.Vel.X <= self.DeAccel then
					self.Vel = Vector(0, self.Vel.Y):RadRotate(self.RotAngle)
				elseif self.Vel.X > self.DeAccel then
					self.Vel = self.Vel + Vector(-self.DeAccel, 0):RadRotate(self.RotAngle)
				elseif self.Vel.X < -self.DeAccel then
					self.Vel = self.Vel + Vector(self.DeAccel, 0):RadRotate(self.RotAngle)
				end
			end
		end
	end

	if self.Health <= 0 then
		self:GibThis()
	end

end

function Destroy(self)

	local tanker1 = CreateAHuman("Loyalist", "Loyalists.rte")
	local sidearm1 = RandomHDFirearm("Weapons - Secondary" , "Loyalists.rte");
	tanker1:AddInventoryItem(sidearm1)
	tanker1.Pos = self.Pos + Vector(-20*self.FlipFactor, -5):RadRotate(self.RotAngle)
	tanker1.Vel = self.Vel
	tanker1.RotAngle = self.RotAngle
	tanker1.HFlipped = self.HFlipped
	tanker1.AIMode = 1
	tanker1.Team = self.Team
	MovableMan:AddActor(tanker1)

	local tanker2 = CreateAHuman("Fanatic", "Loyalists.rte")
	local sidearm2 = RandomHDFirearm("Weapons - Secondary" , "Loyalists.rte");
	tanker2:AddInventoryItem(sidearm2)
	tanker2.Pos = self.Pos + Vector(0, -15):RadRotate(self.RotAngle)
	tanker2.Vel = self.Vel
	tanker2.RotAngle = self.RotAngle
	tanker2.HFlipped = self.HFlipped
	tanker2.AIMode = 1
	tanker2.Team = self.Team
	MovableMan:AddActor(tanker2)

	local tanker3 = CreateAHuman("Loyalist", "Loyalists.rte")
	local sidearm3 = RandomHDFirearm("Weapons - Secondary" , "Loyalists.rte");
	tanker3:AddInventoryItem(sidearm3)
	tanker3.Pos = self.Pos + Vector(20*self.FlipFactor, -5):RadRotate(self.RotAngle)
	tanker3.Vel = self.Vel
	tanker3.RotAngle = self.RotAngle
	tanker3.HFlipped = self.HFlipped
	tanker3.AIMode = 1
	tanker3.Team = self.Team
	MovableMan:AddActor(tanker3)

end