function Create (self)

	self.releaseGas = false
	
	self.gasDelay = (math.random(25,45)*10)
	self.fuzeDelay = (math.random(75,100)*100)
	
	self.angleTable = {}
	self.smallAngle = math.pi/6
	self.angleSet = false
	
	self.smallSmoke = 0.3
	self.bigSmoke = 0.5
	self.pin = false;

end

function Update(self)

	if self.Fuze then
				
		self.Frame = 1;
	
		if math.random() >= self.smallSmoke then
					
			local toxicb = CreateMOSParticle("Toxic Gas Ball 1", "Loyalists.rte")
			toxicb.Pos = self.Pos + Vector(math.random(-1, 1), -2):RadRotate(self.RotAngle)
			toxicb.Vel = self.Vel
			toxicb.Lifetime = 250

			MovableMan:AddParticle(toxicb);
		
		end
		
		if math.random() >= self.bigSmoke then
					
			local toxicc = CreateMOSParticle("Toxic Gas Ball 2", "Loyalists.rte")
			toxicc.Pos = self.Pos + Vector(math.random(-1, 1), -2):RadRotate(self.RotAngle)
			toxicc.Vel = self.Vel
			toxicc.Lifetime = 350

			MovableMan:AddParticle(toxicc);
		
		end
	
		if self.Fuze:IsPastSimMS(self.gasDelay) then	
		
			self.bigSmoke = self.bigSmoke + 0.02
			self.smallSmoke = self.smallSmoke + 0.01
		
			self.angleList = {};
			for i = 1, 12 do
				local angleCheck = self.smallAngle * i;
				for i = 1, 5 do
					local checkPos = self.Pos + Vector(i+1, 0):RadRotate(angleCheck);
					if SceneMan.SceneWrapsX == true then
						if checkPos.X > SceneMan.SceneWidth then
							checkPos = Vector(checkPos.X - SceneMan.SceneWidth, checkPos.Y);
						elseif checkPos.X < 0 then
							checkPos = Vector(SceneMan.SceneWidth + checkPos.X, checkPos.Y);
						end
					end
					local terrCheck = SceneMan:GetTerrMatter(checkPos.X, checkPos.Y);
					if terrCheck ~= rte.airID then
						break;
					end
					if i == 5 then
						self.angleList[#self.angleList + 1] = angleCheck;
					end
				end
			end			

			self.gasDelay = self.gasDelay + 175
			
			local toxica = CreateAEmitter("Toxic Gas", "Loyalists.rte")
			toxica.Pos = self.Pos + Vector(math.random(-3, 3), math.random(-2, 2))
			if #self.angleList > 0 then
				toxica.Vel = self.Vel*math.random()+Vector(math.random(5,10), 0):RadRotate(self.angleList[math.random(#self.angleList)] + RangeRand(-0.1, 0.1));
			else
				toxica.Vel = self.Vel*math.random()+Vector(math.random(5,10), 0):DegRotate(45 * 1 + ((math.random() * 15) - 7.5));
			end
			toxica.Lifetime = 650

			MovableMan:AddParticle(toxica)
			
			local countB = math.ceil(math.random(1,2));
			
			for i = 1, countB do
				local toxicb = CreateAEmitter("Toxic Gas Short", "Loyalists.rte")
				toxicb.Pos = self.Pos + Vector(math.random(-2, 2), math.random(-2, 2))
				if #self.angleList > 0 then
					toxicb.Vel = self.Vel*math.random()+Vector(math.random(8,16), 0):RadRotate(self.angleList[math.random(#self.angleList)] + RangeRand(-0.1, 0.1));
				else
					toxicb.Vel = self.Vel*math.random()+Vector(math.random(8,16), 0):DegRotate(45 * 1 + ((math.random() * 15) - 7.5));
				end
				toxicb.Lifetime = 250

				MovableMan:AddParticle(toxicb)
			end
		end
		
		if self.Fuze:IsPastSimMS(self.fuzeDelay) then
			self:GibThis()
		end

	elseif self:IsActivated() then
	
		if self.pin == false then

			self.pin = true
			
			pin = CreateMOSParticle("Loyalists Grenade Pin", "Loyalists.rte");
			pin.Pos = self.Pos;
			pin.Vel = self.Vel+Vector(0,-6)+Vector(3*math.random(),0):RadRotate(math.random()*(math.pi*2));
			MovableMan:AddParticle(pin);

			sfx = CreateAEmitter("Pin Pulled Sound", "Loyalists.rte");
			sfx.Pos = self.Pos;
			MovableMan:AddParticle(sfx);		
		end
	
		self.Fuze = Timer()
	end
end

