function Create(self)

	self.Frame = 1;
	self.flagTimer = Timer();
	self.rotAngleSize = 0.45;
	
	self.parent = nil;

	self.flagMoraleTargetsTimer = Timer();
	self.flagMoraleTargetsDelay = 650
	self.flagMoraleTargets = {};
	self.flagMaxMoraleRange = 120 + self.Radius
	
	self.SupportOffset = Vector(3,6)
end

function Update(self)
	if self.flagTimer:IsPastSimMS(75) then
		self.flagTimer:Reset();
		if self.Magazine then
			if self.Magazine.Frame == self.Magazine.FrameCount-1 then
				self.Magazine.Frame = 0;
			else
				self.Magazine.Frame = self.Magazine.Frame + 1;
			end
		end
	end

	if self:IsAttached() == true then 		--I think this is more performance friendly as it doesn't check the self.parent every frame, rather just when the gun is first taken.
		if self.parent == nil then
			if IsAHuman(self:GetRootParent()) then
				self.parent = ToAHuman(self:GetRootParent())
			end
		end
	else
		self.parent = nil;
	end


	if self.parent then
		self.InheritedRotAngleOffset = 1*self.rotAngleSize;
	
		if self:IsAttached() and (self.parent.PresetName == "Loyalist" or self.parent.PresetName == "Fanatic" or self.parent.PresetName == "Zealot" or self.parent.PresetName == "Loyal Officer" or self.parent.PresetName == "Loyal Commissar" or self.parent.PresetName == "Loyal Pilot" or self.parent.PresetName == "Loyal Tanker") then
			self.parent:SetNumberValue("Flag Bearer Morale", 2)
			self.parent:SetNumberValue("Flag Morale", 2)
		end
	end
		
	if self.flagMoraleTargetsTimer:IsPastSimMS(self.flagMoraleTargetsDelay) then
		self.flagMoraleTargetsTimer:Reset();
		for i = 1, #self.flagMoraleTargets do
			local flagMoraleTarget = self.flagMoraleTargets[i];
			if flagMoraleTarget and IsActor(flagMoraleTarget) then
				flagMoraleTarget:SetNumberValue("Flag Morale", 2)
			end
		end

		self.flagMoraleTargets = {};

		for act in MovableMan.Actors do
			if act.Team == self.Team and act.UniqueID ~= self.UniqueID and (act.PresetName == "Loyalist" or act.PresetName == "Fanatic" or act.PresetName == "Zealot" or act.PresetName == "Loyal Officer" or act.PresetName == "Loyal Commissar" or act.PresetName == "Loyal Pilot" or act.PresetName == "Loyal Tanker") then
				local trace = SceneMan:ShortestDistance(self.Pos, act.Pos, false);
				if (trace.Magnitude - act.Radius) < self.flagMaxMoraleRange then
					local strSumCheck = SceneMan:CastStrengthSumRay(self.Pos, self.Pos + trace, 3, rte.airID);
					if strSumCheck < 10 then
						table.insert(self.flagMoraleTargets, act);
					end
				end
			end
		end
	end
end