function Create(self)

	self.attackType = {}

	local attackStage
	local i;

	attackStage = {}

	------ Idle --------
	self.normalStance = Vector(3,5)
	self.normalAngle = 0.8
	self.normalSpeed = 12

	------- Preparing Attack -------
	i = 1
	attackStage[i] = {}
	attackStage[i].stance = Vector(-4,6)
	attackStage[i].angle = 0.35
	attackStage[i].angleSpeed = 12

	attackStage[i].canAttack = false

	attackStage[i].duration = 135
	
	-------- Launching Attack ---------
	---Early attack
	i = 2
	attackStage[i] = {}
	attackStage[i].stance = Vector(10,5)
	attackStage[i].angle = 0.25
	attackStage[i].angleSpeed = 3
	
	attackStage[i].canAttack = false
	
	attackStage[i].duration = 40

	---Mid attack
	i = 3
	attackStage[i] = {}
	attackStage[i].stance = Vector(13,3)
	attackStage[i].angle = 0.1
	attackStage[i].angleSpeed = 3
	
	attackStage[i].canAttack = false

	attackStage[i].duration = 40

	---Late attack
	i = 4
	attackStage[i] = {}
	attackStage[i].stance = Vector(16,1)
	attackStage[i].angle = 0
	attackStage[i].angleSpeed = 3
	
	attackStage[i].canAttack = true

	attackStage[i].duration = 100

	--------- Recovery --------
	i = 5
	attackStage[i] = {}
	attackStage[i].stance = Vector(12,3)
	attackStage[i].angle = 0.45
	attackStage[i].angleSpeed = 12
	
	attackStage[i].canAttack = false

	attackStage[i].duration = 60

	-------- Normal again -------
	i = 6
	attackStage[i] = {}
	attackStage[i].stance = self.normalStance
	attackStage[i].angle = self.normalAngle
	attackStage[i].angleSpeed = 12
	
	attackStage[i].canAttack = false

	attackStage[i].duration = 60

	self.attackType[1] = attackStage

	--------- Other Values ---------

	self.whatStage = 0

	self.animationTimer = Timer();
	self.isAttacking = false

	self.angleNum = 0
	self.origAngleNum = self.normalAngle
	
	self.modifiedAngle = self.normalAngle
	self.modifiedSpeed = self.normalSpeed
	
	self.spawnAttack = true
	self.canAttack = false;

	self.parent = nil

	self.heldSpriteOffset = Vector(-3,-3)
	self.orgSpriteOffset = Vector(-8,-3)

	self.Frame = math.random(0, self.FrameCount - 2)

end

function Update(self)

	if self:IsAttached() == true then 		--I think this is more performance friendly as it doesn't check the parent every frame, rather just when the gun is first taken.
		self.SpriteOffset = self.heldSpriteOffset
		self.GetsHitByMOs = false;
		if self.parent == nil then
			if IsAHuman(self:GetRootParent()) then
				self.parent = ToAHuman(self:GetRootParent())
			end
		end
	else
		self.parent = nil;
		self.SpriteOffset = self.orgSpriteOffset
		self.GetsHitByMOs = true;
	end

	if self.parent then 

		if self.origAngleNum > self.modifiedAngle then
			if self.angleNum > self.modifiedAngle then
				self.angleNum = self.angleNum -1*0.01*self.modifiedSpeed;
			else
				self.angleNum = self.modifiedAngle
			end
		elseif self.origAngleNum < self.modifiedAngle then
			if self.angleNum < self.modifiedAngle then
				self.angleNum = self.angleNum +1*0.01*self.modifiedSpeed;
			else
				self.angleNum = self.modifiedAngle
			end
		else
			self.angleNum = self.modifiedAngle
		end

		self.RotAngle = self.RotAngle+self.FlipFactor*self.angleNum

		self.parent:GetController():SetState(Controller.AIM_SHARP,false);

		if self:IsActivated() and self.isAttacking == false then
			self.isAttacking = true
			self.animationTimer:Reset()
			self.whatStage = 1
			self.spawnAttack = true
		end
		
		if self.isAttacking == true then

			local attackStages = self.attackType[1]
			local currentStage = attackStages[self.whatStage]
			local currentStageAttack = attackStages[self.whatStage]

			self.StanceOffset = currentStage.stance	
			self.modifiedAngle = currentStage.angle
			self.modifiedSpeed = currentStage.angleSpeed

			self.canAttack = currentStage.canAttack
			
			if self.spawnAttack == true and self.canAttack == true then

				local weaponPos = self.Pos + Vector((13*self.FlipFactor), 1):RadRotate(self.RotAngle)
				local weaponCheck = Vector((13*self.FlipFactor), -2):RadRotate(self.RotAngle)
						
--				PrimitiveMan:DrawLinePrimitive(self.Team, weaponPos, self.Pos + weaponCheck, 13);
		
				local moCheck = SceneMan:CastMORay(weaponPos, weaponCheck, rte.NoMOID, self.Team, rte.airID, true, 1);
				if moCheck and moCheck ~= rte.NoMOID then
					local mo = MovableMan:GetMOFromID(moCheck);

					for i = 0, 2 do
						local part = CreateMOPixel("Knife Strike", "Loyalists.rte");
						part.Pos = self.Pos + Vector((7+i*2)*self.FlipFactor, 0):RadRotate(self.RotAngle)
						part.Vel = self.Vel + Vector(10*self.FlipFactor,0):RadRotate(self.RotAngle)
						part.Team = self.parent.Team;	part.IgnoresTeamHits = true;
						MovableMan:AddParticle(part);
					end

					if IsActor(mo:GetRootParent()) then
						local actor = ToActor(mo:GetRootParent());
--[[
						local damage = math.random(10,25)		--Make it class dependant
						actor.Health = actor.Health - damage
					
						local disarm = math.random()			--Same as above
						if disarm > 0.85 then
							actor:GetController():SetState(Controller.WEAPON_DROP,true)
						end
--]]
					end
					self.spawnAttack = false;
				end
			end

			if self.animationTimer:IsPastSimMS(currentStage.duration) then
				self.spawnAttack = true
				
				self.origAngleNum = self.angleNum
				
				self.animationTimer:Reset();
				
				if self.whatStage < #attackStages then
					self.whatStage = self.whatStage + 1
				else
					self.isAttacking = false
				end
			end
		end
	end
end