function Create(self)

	self.attackType = {}

	local attackStage
	local i;

	attackStage = {}

	------ Idle --------
	self.normalStance = Vector(3,5)
	self.normalAngle = 0.8
	self.normalSpeed = 12

	------- Preparing Attack -------
	i = 1
	attackStage[i] = {}
	attackStage[i].stance = Vector(3,-4)
	attackStage[i].angle = 2.6
	attackStage[i].angleSpeed = 10

	attackStage[i].canAttack = false

	attackStage[i].duration = 320
	
	-------- Launching Attack ---------
	---Early attack
	i = 2
	attackStage[i] = {}
	attackStage[i].stance = Vector(10,-3)
	attackStage[i].angle = 1
	attackStage[i].angleSpeed = 17
	
	attackStage[i].canAttack = false

	attackStage[i].duration = 110

	---Mid attack
	i = 3
	attackStage[i] = {}
	attackStage[i].stance = Vector(13,2)
	attackStage[i].angle = 0
	attackStage[i].angleSpeed = 17
	
	attackStage[i].canAttack = true

	attackStage[i].duration = 125

	---Late attack
	i = 4
	attackStage[i] = {}
	attackStage[i].stance = Vector(11,7)
	attackStage[i].angle = -0.75
	attackStage[i].angleSpeed = 17
	
	attackStage[i].canAttack = false

	attackStage[i].duration = 100

	--------- Recovery --------
	i = 5
	attackStage[i] = {}
	attackStage[i].stance = Vector(8,4)
	attackStage[i].angle = 0.25
	attackStage[i].angleSpeed = 10
	
	attackStage[i].canAttack = false

	attackStage[i].duration = 150

	-------- Normal again -------
	i = 6
	attackStage[i] = {}
	attackStage[i].stance = self.normalStance
	attackStage[i].angle = self.normalAngle
	attackStage[i].angleSpeed = self.normalSpeed
	
	attackStage[i].canAttack = false

	attackStage[i].duration = 125

	self.attackType[1] = attackStage

	--------- Other Values ---------

	self.whatStage = 0

	self.animationTimer = Timer();
	self.isAttacking = false

	self.angleNum = 0
	self.origAngleNum = self.normalAngle
	
	self.modifiedAngle = self.normalAngle
	self.modifiedSpeed = self.normalSpeed
	
	self.spawnAttack = true
	self.canAttack = false;

	self.parent = nil

	self.heldSpriteOffset = Vector(-2,-2)
	self.orgSpriteOffset = Vector(-10,-2)

	self.Frame = math.random(0, self.FrameCount - 2)

end

function Update(self)

	if self:IsAttached() == true then 		--I think this is more performance friendly as it doesn't check the parent every frame, rather just when the gun is first taken.
		self.SpriteOffset = self.heldSpriteOffset
		self.GetsHitByMOs = false;
		if self.parent == nil then
			if IsAHuman(self:GetRootParent()) then
				self.parent = ToAHuman(self:GetRootParent())
			end
		end
	else
		self.parent = nil;
		self.SpriteOffset = self.orgSpriteOffset
		self.GetsHitByMOs = true;
	end

	if self.parent then 

		if self.origAngleNum > self.modifiedAngle then
			if self.angleNum > self.modifiedAngle then
				self.angleNum = self.angleNum -1*0.01*self.modifiedSpeed;
			else
				self.angleNum = self.modifiedAngle
			end
		elseif self.origAngleNum < self.modifiedAngle then
			if self.angleNum < self.modifiedAngle then
				self.angleNum = self.angleNum +1*0.01*self.modifiedSpeed;
			else
				self.angleNum = self.modifiedAngle
			end
		else
			self.angleNum = self.modifiedAngle
		end

		self.RotAngle = self.RotAngle+self.FlipFactor*self.angleNum

		self.parent:GetController():SetState(Controller.AIM_SHARP,false);

		if self:IsActivated() and self.isAttacking == false then
			self.isAttacking = true
			self.animationTimer:Reset()
			self.whatStage = 1
			self.spawnAttack = true
		end
		
		if self.isAttacking == true then

			local attackStages = self.attackType[1]
			local currentStage = attackStages[self.whatStage]
			local currentStageAttack = attackStages[self.whatStage]

			self.StanceOffset = currentStage.stance	
			self.modifiedAngle = currentStage.angle
			self.modifiedSpeed = currentStage.angleSpeed

			self.canAttack = currentStage.canAttack
			
			if self.spawnAttack == true and self.canAttack == true then

				local weaponPos = self.Pos + Vector((11*self.FlipFactor), 4):RadRotate(self.RotAngle)
				local weaponCheck = Vector((17*self.FlipFactor), 4):RadRotate(self.RotAngle)
						
--				PrimitiveMan:DrawLinePrimitive(self.Team, weaponPos, self.Pos + weaponCheck, 13);
		
				local moCheck = SceneMan:CastMORay(weaponPos, weaponCheck, rte.NoMOID, self.Team, rte.airID, true, 1);
				if moCheck and moCheck ~= rte.NoMOID then
					local mo = MovableMan:GetMOFromID(moCheck);
					local limbSevered = false;

					if IsAHuman(mo:GetRootParent()) and IsAttachable(mo) and ToAttachable(mo):IsAttached() then
						local actor = ToAHuman(mo:GetRootParent())
						local limb = ToAttachable(mo)

						if string.find(mo.PresetName, "Head") or string.find(mo.PresetName, "Arm") or string.find(mo.PresetName, "Leg") then
							local dismember = math.random()			--Same as above
							if dismember > 0.95 and actor.Health < 35 then
								if limb:IsAttached() then
									limbSevered = true;
									limb:RemoveFromParent(true,true)
									limb.Vel = actor.Vel + Vector(3*self.FlipFactor,-1):RadRotate(actor.RotAngle)
								end
								actor:FlashWhite(20)
							end
						end
					end
			
					if limbSevered == false then
						for i = 0, 3 do
							local part = CreateMOPixel("Shovel Strike", "Loyalists.rte");
							part.Pos = self.Pos + Vector(((11+i*2)*self.FlipFactor), 4):RadRotate(self.RotAngle)
							part.Vel = self.Vel + Vector(0, 10):RadRotate(self.RotAngle)
							part.Team = self.parent.Team;	part.IgnoresTeamHits = true;
							MovableMan:AddParticle(part);
						end	
					end
					
					self.spawnAttack = false;
				end
			end

			if self.animationTimer:IsPastSimMS(currentStage.duration) then
				self.spawnAttack = true
				
				self.origAngleNum = self.angleNum
				
				self.animationTimer:Reset();
				
				if self.whatStage < #attackStages then
					self.whatStage = self.whatStage + 1
				else
					self.isAttacking = false
				end
			end
		end
	end
end